/* Problem URL: https://codeforces.com/problemset/problem/2118/D1 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, k;
    cin >> n >> k;

    vl p(n);
    vl d(n);
    cin >> p >> d;

    V<V<bool>> loop(n, V<bool>(2));
    V<V<bool>> vis(n, V<bool>(2));
    V<V<bool>> frame(n, V<bool>(2));

    function<bool(int, int, ll)> func = [&](int i, int dir, ll cur) -> bool {
        if (cur % k != d[i]) {
            int ne = i + 1 - 2 * dir;
            if (ne < 0 || ne == n) {
                return false;
            }

            return func(ne, dir, (cur + abs(p[i] - p[ne])) % k);
        }

        dir ^= 1;

        if (frame[i][dir]) {
            frame[i][dir] = false;
            loop[i][dir] = true;
            return true;
        }

        if (vis[i][dir]) {
            return false;
        }

        vis[i][dir] = true;
        frame[i][dir] = true;

        int ne = i + 1 - 2 * dir;
        if (ne < 0 || ne == n) {
            frame[i][dir] = false;
            return false;
        }
        bool res = func(ne, dir, (cur + abs(p[i] - p[ne])) % k);

        if (res == true) {
            loop[i][dir] = true;
        }

        frame[i][dir] = false;
        return loop[i][dir];
    };

    rep(i, n) {
        if (!vis[i][0]) {
            func(i, 1, d[i]);
        }

        if (!vis[i][1]) {
            func(i, 0, d[i]);
        }
    }

    int q;
    cin >> q;
    while (q--) {
        ll c;
        cin >> c;

        int ind = lower_bound(all(p), c) - p.begin();
        bool pos = true;
        ll cur = 0;
        while (ind < n) {
            cur = (cur + abs(p[ind] - c)) % k;
            if (cur == d[ind]) {
                if (loop[ind][1]) {
                    pos = false;
                }
                break;
            }
            c = p[ind];
            ind++;
        }

        cout << (pos ? "YES\n" : "NO\n");
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
